'use strict';

var UpsConfig = function(){
    var vars = {
            $selectModemType : $("#select-modem-type"),
            $gsmModemForm : $("#modem-gsm"),
            $analogModemForm : $("#modem-analog"),
            dbg: true
        },

        fetchConfiguration = function fetchConfiguration (){
            return $.ajax({
                url:'cgi-bin/config.cgi',
                method: 'get',
                dataType : 'json'
            })
        },
        enableSSHSections = function enableSSHSections(cfg) {
            vars.cfg = cfg;

            if (vars.cfg.ssh_enable === true) {
                //enable add_sensor tab
                initSshAuth();
            }
        },
        applyConfiguration = function applyConfiguration(cfg){
            var dfr = $.Deferred();

            if (Main.whoIsLoggedIn() === "power") {
                $("#tab_command_config").addClass("hidden");
            }
            else {
                $("#tab_command_config").removeClass("hidden");
            }

            $.each(cfg, function(k,v){
                switch(k){
                case "ups_mainteinance":
                    v = convertDate(v, "YYYY-MM-DD", "DD/MM/YYYY");
                    break;
                case "device_prtk":
                    v = v.substring(0,10) + "--";
                    switch (v) {
                        case "GPSER11201--":
                        case "GPSER19601--":
                        case "SENTR19601--":
                        case "SENTR11201--":
                            $("#tab_datalog").removeClass("hidden");
                            $(".box-generic-tunneling").removeClass("hidden");
                            $("#tab_bacnetModbus").text("MODBUS/BACNET");
                            $("#label-bacnet").text("MODBUS/BACNET configuration");
                            $(".box-bacnet-enable").removeClass("hidden");
                            $(".box-bacnet-data").removeClass("hidden");
                            $("#tab_UDPFirewall").removeClass("hidden");
                            $("#tab_JSON").removeClass("hidden");
                            $("#evt_6").text("Battery low");
                            $("#tab_Email").removeClass("hidden");
                            $("#tab_EmailTitle").removeClass("hidden");
                            $("#batt_replacement").removeClass("hidden");
                            if (v == "SENTR11201--" ||
                                v == "SENTR19601--") {
                                $(".onlyforSentry").removeClass("hidden");
                            }
                            else {
                                $(".onlyforSentry").addClass("hidden");
                            }
                            break;
                        default:
                            $("#tab_datalog").addClass("hidden");
                            $(".box-generic-tunneling").addClass("hidden");
                            $("#tab_bacnetModbus").text("MODBUS");
                            $("#label-bacnet").text("MODBUS configuration");
                            $(".box-bacnet-enable").addClass("hidden");
                            $(".box-bacnet-data").addClass("hidden");
                            $("#tab_UDPFirewall").removeClass("hidden");
                            $(".box-generic-udp").removeClass("hidden");
                            $("#tab_Email").removeClass("hidden");
                            $("#tab_EmailTitle").removeClass("hidden");
                            $(".onlyforSentry").addClass("hidden");
                            $("#tab_JSON").addClass("hidden");
                            switch (v) {
                                case "GPSER31201--":
                                    $("#evt_6").text("Transfer Active");
                                    $("#batt_replacement").addClass("hidden");
                                    break;
                                case "GPSER51201--":
                                    //+++Abilito bacnet
                                    $("#tab_bacnetModbus").text("MODBUS/BACNET");
                                    $("#label-bacnet").text("MODBUS/BACNET configuration");
                                    $(".box-bacnet-enable").removeClass("hidden");
                                    $(".box-bacnet-data").removeClass("hidden");
                                    //+++
                                    $("#tab_Email").addClass("hidden");
                                    $("#tab_EmailTitle").addClass("hidden");
                                    $("#tab_UDPFirewall").addClass("hidden");
                                    $(".box-generic-udp").addClass("hidden");
                                    $("#batt_replacement").removeClass("hidden");
                                    $("#tab_JSON").removeClass("hidden");
                                    break;
                                case "IRSER11201--":
                                    $("#tab_UDPFirewall").addClass("hidden");
                                    $(".box-generic-udp").addClass("hidden");
                                    $("#evt_6").text("Transfer Active");
                                    $("#batt_replacement").addClass("hidden");
                                    break;
                            }
                            break;
                    }
                    break;
                case "udp_password":
                    $("#udp_pwd1").val(v);
                    $("#udp_pwd2").val(v);
                    break;
                default: break;
                }
                var $elem = $("[name="+k+"]");

                if(!$elem.is(":disabled")){
                    setFormElement($elem, v);
                }

                jcf.refresh( $elem );
                $elem.trigger("change");
            });

            if (!cfg.snmp_version){
                cfg.snmp_version=1;
                $("#opt-snmp-v1").prop("checked", true);
            }

            //enable snmp_version tab
            if(cfg.snmp_version){
                var $trigger = $("input[name='snmp_version'][value="+cfg.snmp_version+"]");

                var $wizardTab = $("#wizard");
                var $fileTab = $("#file");
                var $wizardvTab = $("#vtab1");
                var $filevTab = $("#vtab2");

                if (cfg.snmp_version != 'F') {
                    $wizardTab.addClass("active");
                    $fileTab.removeClass("active");

                    $wizardvTab.addClass("in active");
                    $wizardvTab.find("fieldset").prop("disabled", false);
                    jcf.refreshAll($wizardvTab);

                    $filevTab.removeClass("in active");
                    $filevTab.find("fieldset").prop("disabled", "disabled");
                }
                else {
                    $wizardTab.removeClass("active");
                    $fileTab.addClass("active");

                    $filevTab.addClass("in active");
                    $filevTab.find("fieldset").prop("disabled", false);
                    jcf.refreshAll($filevTab);

                    $wizardvTab.removeClass("in active");
                    $wizardvTab.find("fieldset").prop("disabled", "disabled");
                }

                // scrivo contenuto file /etc/snmp.conf nel box a lui dedicato
                $.ajax({
                    type: 'get',
                    url:'cgi-bin/get_snmp_conf.cgi',
                    data: "{}",
                    async: true,
                    dataType: "text",
                    success: function( data ) {
                        $("#config_file").text( data );
                    }
                });

                if($trigger.size()>0){
                    $trigger.tab('show');

                    var $activeTab = $($trigger.data("target"));

                    //activate tab
                    $activeTab.find("fieldset").prop("disabled", false);
                    jcf.refreshAll($activeTab);

                    //disable siblings
                    var $otherTabs = $activeTab.siblings(".tab-pane");

                    $otherTabs.find("fieldset").prop("disabled", "disabled");

                    // $.each($otherTabs, function(i,e){
                    //     resetInnerFields($(e));
                    // });
                }
            }

            if((! (cfg.ups_shutdown_disable)))
            {
                $("#tab-command-shutdown").removeClass("disabled");
                $("#tab-command-restore").removeClass("disabled");
            }

            if (Main.OSVersion() === "W18-1") {
                $("#tab_SSH").removeClass("hidden");
            }

            dfr.resolve(cfg);
            return dfr;
        },

        initConfigurationForms = function initConfigurationForms(cfg){

            $(".js-reset-modem-config").on("click", function(e){
                e.preventDefault();

                vars.$gsmModemForm.hide();
                resetInnerFields(vars.$gsmModemForm);
                vars.$analogModemForm.hide();
                resetInnerFields(vars.$analogModemForm);

                vars.$selectModemType.show();
            });

            $(".js-gsm-modem").on("click", function(e){
                e.preventDefault();
                vars.$selectModemType.hide();
                vars.$gsmModemForm.show();
            });

            $(".js-analog-modem").on("click", function(e){
                e.preventDefault();
                vars.$selectModemType.hide();
                vars.$analogModemForm.show();
            });

            $('input[name="snmp_version"]').on("change", function () {
                var $trigger = $(this);
                $trigger.tab('show');
                var $activeTab = $($trigger.data("target"));

                //activate tab
                $activeTab.find("fieldset").prop("disabled", false);
                jcf.refreshAll($activeTab);

                //disable siblings
                var $otherTabs = $activeTab.siblings(".tab-pane");
                $otherTabs.find("fieldset").prop("disabled", "disabled");

                // $.each($otherTabs, function(i,e){
                //     resetInnerFields($(e));
                // });

            });

            $('input[name=http_enable]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=https_enable]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });

            $('input[name=https_enable]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=http_enable]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });

            $('input[name=email_report_daily]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=email_report_weekly]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });

            $('input[name=email_report_weekly]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=email_report_daily]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });

            $('input[name=sms_report_daily]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=sms_report_weekly]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });

            $('input[name=sms_report_weekly]').on("change", function(){
                var $this = $(this);
                if($this[0].checked){
                    var altInput = $('input[name=sms_report_daily]');
                    altInput[0].checked = false;
                    altInput.trigger("change");
                    jcf.refresh( altInput );
                }
            });
            //manual triggering external form from email configuration form
            /*$(".email-config-test__submit").on("click", function(){
               $(".email-config-test").submit();
            });*/

            // ------ SECTIONS LOCK -------
            disableInnerOnChange( $("#http_enable") , $("#http-config") );
            disableInnerOnChange( $("#https_enable") , $("#https-config") );
            disableInnerOnChange( $("#udp_enable") , $("#udp-config") );
            disableInnerOnChange( $("#net_dhcp_enabled") , $("#static-ip-config"), true);
            disableInnerOnChange( $("#firewall_enable") , $("#firewall-ip-config") );
            disableInnerOnChange( $("#wol_enable") , $("#wol-mac-config") );
            disableInnerOnChange( $("#ssh_client_enable") , $("#ssh-client-config") );
            disableInnerOnChange( $("#after_mains_failure") , $("#after_mains_ssh") );
            disableInnerOnChange( $("#threshod_autonomy") , $("#autonomy_ssh") );

            // disableInnerOnChange( $("#snmp_enable") , $("#snmp-config") );
            $("#snmp_enable").on("change", function(){
                if( $("#snmp_enable").is(":checked") ){
                    $("#snmp-config").find("input, select, textarea, button").each(function(){
                        $(this).prop("disabled", false);
                    });
                    $("#vtab2").removeClass("hidden");
                } else {
                    $("#snmp-config").find("input, select, textarea, button").each(function(){
                        $(this).attr('data-default-value',$(this).val());
                        $(this).prop("disabled", "disabled");
                    });
                    resetInnerFields($("#snmp-config"));
                    $("#vtab2").addClass("hidden");
                }
                jcf.refreshAll($("#snmp-config"));
            });

            $("#snmp_enable").trigger("change");

            disableInnerOnChange( $("#bacnet_enable") , $("#bacnet-config") );
            disableInnerOnChange( $("#email_enable") , $("#email-config") );
            disableInnerOnChange( $("#email_report_enable") , $("#email-report-config") );
            disableInnerOnChange( $("#sms_enable") , $("#sms-modem-config") );
            disableInnerOnChange( $("#modem_tx_enable") , $("#analog-modem-config") );
            disableInnerOnChange( $("#jsontrap_enable") , $("#jsontrap-config") );
            disableInnerOnChange( $("#syslog_enable") , $("#syslog-config") );

            // slot che disabilita la scelta file/wizard non propagando il click
            $("#nav-modesnmp").on("click", function(e) {
                if( $("#snmp_enable").is(":checked") ) {
                    e.preventDefault();
                    if ($("#wizard").hasClass("active")) {
                        $("#opt-snmp-v1").prop("checked", false);
                        $("#opt-snmp-v3").prop("checked", false);
                        $("#opt-snmp-v0").prop("checked", false);
                        $("#opt-snmp-file").prop("checked", true);
                        $("#vtab2").find("fieldset").prop("disabled", false);
                        $("#vtab1").find("fieldset").prop("disabled", "disabled");
                    }
                    else {
                        if (cfg.snmp_version == "1") {
                            $("#opt-snmp-v1").prop("checked", true);
                            $("#opt-snmp-v3").prop("checked", false);
                            $("#opt-snmp-v0").prop("checked", false);
                        }
                        else if (cfg.snmp_version == "3") {
                            $("#opt-snmp-v1").prop("checked", false);
                            $("#opt-snmp-v3").prop("checked", true);
                            $("#opt-snmp-v0").prop("checked", false);
                        }
                        else {
                            $("#opt-snmp-v1").prop("checked", false);
                            $("#opt-snmp-v3").prop("checked", false);
                            $("#opt-snmp-v0").prop("checked", true);
                        }
                        $("#vtab2").find("fieldset").prop("disabled", "disabled");
                        $("#vtab1").find("fieldset").prop("disabled", false);
                        $("#opt-snmp-file").prop("checked", false);
                    }
                }
                else
                    return false;
            });

            // slot che forza un riavvio applicativo dopo un cambio prtk
            $("#device_prtk").on("change", function(e){
                // compilo i campi della modale con quanto presente nella pagine di configurazione
                $('#device_prtk_modal').val($('#device_prtk').val());
                $('#device_name_modal').val($('#device_name').val());
                $('#change-prtk-modal').modal('show');
            });

            // ------ INIT FORM VALIDATION -----
            $("form").each(function(i,form){
                var $form = $(form);

                //prevent normal submit
                $form.submit(function(e){e.preventDefault();});


                if($form.hasClass('network-config')){
                    $form.validate({
                        submitHandler : submitConfigHandler,
                        rules: {
                            udp_pwd2: {equalTo: '#udp_pwd1'}
                        }
                    });
                }
                else if($form.hasClass('snmp-config')){
                    $form.validate({
                        submitHandler : submitConfigHandler,
                        ignore: ':hidden'
                    });
                }
                else if($form.hasClass('modem-config')){
                    //if modem form, send both on save
                    $form.validate({
                        submitHandler : submitModemHandler,
                        ignore:''
                    });
                }
                else{
                    $form.validate({
                        submitHandler : submitConfigHandler
                    });
                }
            });
        },

        submitConfigHandler = function submitConfigHandler(form){
            var $form = $(form),
                $submit = $form.find("input[type=submit]"),
                url = $form.attr("action"),
                method = $form.attr("method"),
                formData = $form.serializeArray({ checkboxesAsBools: true }),
                data = formData,
                submitTxt = $submit.val();

            data = _.chain(data)
                .indexBy('name')
                .mapValues('value')
                .value();

            if($form.hasClass("device-general-config")){
                ;
            }
            else if($form.hasClass("network-config")){

                if( data.http_enable === "true" && (typeof data.http_port === 'undefined' || data.http_port === "")){
                    data.http_port = 80;
                }
                if( data.https_enable === "true" && (typeof data.https_port === 'undefined' || data.https_port === "")){
                    data.https_port = 443;
                }
                if( data.udp_enable === "true" && (typeof data.udp_port === 'undefined' || data.udp_port === "")){
                    data.udp_port = 33000;
                }

                var pwd = data.udp_pwd1;
                if(pwd !== "" && pwd === data.udp_pwd2){
                    data.udp_password = pwd;
                }
                delete data.udp_pwd1;
                delete data.udp_pwd2;
            }
            else if($form.hasClass("email-config")){

                if( data.email_enable === "true" && (typeof data.email_port === 'undefined' || data.email_port === "")){
                    data.email_port = 25;
                }
            }
            else if($form.hasClass("clock-config")){
                //data.clock = data.clock_date + " " + data.clock_hour+":"+data.clock_minutes+":"+data.clock_seconds;
                var ckDate = moment(data.clock_date + " " + data.clock_hour+":"+data.clock_minutes, "DD/MM/YYYY HH:mm");

                if(ckDate.isValid() === true){
                    data.clock = convertDate(ckDate, "DD/MM/YYYY HH:mm", "MMDDHHmmYYYY");
                }else{
                    delete  data.clock;
                }

                delete data.clock_date;
                delete data.clock_hour;
                delete data.clock_minutes;
                //delete data.clock_seconds;
            }
            else if($form.hasClass("snmp-config")){
                data = {};
                $.each(formData, function(i, e) {
                    if(data[e.name] === undefined || data[e.name] === ""){
                        data[e.name] = e.value;
                    }
                });
                // non so perche' cancella e rilegga data, ma ora si possono scambiare i campi della data
                if(data.ups_mainteinance){
                    data.ups_mainteinance = convertDate(data.ups_mainteinance, "DD/MM/YYYY", "YYYY-MM-DD");
                }else{
                    delete data.ups_mainteinance;
                }
            }
            else if($form.hasClass("email-config-test")){
                $submit = $(".email-config-test__submit");
            }

            // append token to sent data
            // (just before sending the form, so it wont be overwritten)
            data.token = Cookies.get("token");

            //btn to saving state
            $submit.val(Config.get("waitMessage")).prop("disabled", "disabled");

            var xhr = $.ajax({
                url: url,
                method: method,
                data: data
            });
            xhr.done(function(data){
                var res = JSON.parse(data);

                if(res.response === "ok"){
                    showSuccess(res.message, false, res.debug);
                    $("#change-prtk-modal").modal('hide');
                    $submit.val(Config.get("btnSaveSuccessMessage"))
                        .removeClass("btn-primary")
                        .addClass("btn-success");
                }else{
                    showInfo(res.message, false, res.debug);
                    $submit.val(Config.get("btnSaveErrorMessage"))
                        .removeClass("btn-primary")
                        .addClass("btn-danger");
                }
            });
            xhr.error(function(err){
                showError(err.statusText);
                $submit.val(Config.get("btnSaveErrorMessage"))
                    .removeClass("btn-primary")
                    .addClass("btn-danger");
            });
            xhr.always(function(){
                //btn back to initial state
                Main.setLastSaveConfigButton();
                window.setTimeout(function(){
                    $submit.val(submitTxt)
                        .prop("disabled", false)
                        .removeClass("btn-danger")
                        .removeClass("btn-success")
                        .addClass("btn-primary");
                }, Config.get("feedbackMessageDuration"));
            });
        },

        submitModemHandler = function submitModemHandler(form){

            //no more submit both forms, using -- deferSubmitHandler --
            var $activeForm = $(form),
                $submit = $activeForm.find("input[type='submit']"),
                btnDefaultText = $submit.val();

            $submit.prop('disabled', 'disabled').val(Config.get("waitMessage"));

            $.when( deferSubmitHandler($activeForm) )
                .then(
                    function(r1, r2){
                        showSuccess(r1.message);
                        $submit.removeClass('btn-primary')
                            .addClass('btn-success')
                            .val(Config.get("btnSaveSuccessMessage"));
                    },
                    function (r1, r2){
                        showError(Config.get("btnSaveErrorMessage"));
                        $submit.removeClass('btn-primary')
                            .addClass('btn-danger')
                            .val(Config.get("btnSaveErrorMessage"));
                    }
                )
                .always(
                    function(){

                        window.setTimeout(function(){
                            $submit.val(btnDefaultText)
                                .prop("disabled", false)
                                .removeClass("btn-danger")
                                .removeClass("btn-success")
                                .addClass("btn-primary");
                        }, Config.get("feedbackMessageDuration"));
                    }
                );
        },

        deferSubmitHandler = function deferSubmitHandler(form){
            var defer = $.Deferred(),
                $form = $(form),
                url = $form.attr("action"),
                method = $form.attr("method"),
                data = $form.serializeArray({ checkboxesAsBools: true });

            data = _.chain(data).indexBy('name').mapValues('value').value();

            data.token = Cookies.get("token");

            var xhr = $.ajax({
                url: url,
                method: method,
                data: data
            });
            xhr.done(function(data){
                var res = JSON.parse(data);
                if(res.response === "ok"){
                    defer.resolve(res);
                }else{
                    defer.reject(res);
                }
            });
            xhr.error(function(err){
                defer.reject(err);
            });

            return defer;
        },

        sshAuthListener1 = function sshAuthListener1() {
            return $.ajax({
                url: 'cgi-bin/ssh_auth.cgi',
                method: 'post',
                data: { ssh_server: $("#ssh_client_server1").val(), token: Cookies.get("token")} ,
                dataType: 'json'
            });
        },
        sshAuthListener2 = function sshAuthListener2() {
            return $.ajax({
                url: 'cgi-bin/ssh_auth.cgi',
                method: 'post',
                data: { ssh_server: $("#ssh_client_server2").val(), token: Cookies.get("token")} ,
                dataType: 'json'
            });
        },
/*
        sshCredentialsListener1 = function sshCredentialsListener() {
            return $.ajax({
                url: 'cgi-bin/ssh_credentials.cgi',
                method: 'post',
                data: { ssh-credentials: $("#ssh_client_server1").val(), ssh-password: $("#ssh_password").val()} ,
                dataType: 'json'
            });
        },
*/
        sshValidate1 = function sshValidate() {
            var sshListenerXHR = sshAuthListener1();
            sshListenerXHR
                .done(function (res) {
                    if (res.response === "ok") {
                        showSuccess(res.message)
                        $("#ssh-check-1").removeClass("hidden")
                        //$("#ssh-title-1").html("hidden")
                        var cred = $("#ssh_client_server1").val()
                        //$("#ssh-title-1").html($("#ssh_server1").text())
                        $("#ssh-title-1").html("ssh " + cred)
                    }
                })
            sshListenerXHR.error(function (err) {
                showError(err.statusText)
            });
        },
        sshValidate2 = function sshValidate() {
            var sshListenerXHR = sshAuthListener2();
            sshListenerXHR
                .done(function (res) {
                    if (res.response === "ok") {
                        showSuccess(res.message)
                        $("#ssh-check-2").removeClass("hidden")
                        //$("#ssh-title-1").html("hidden")
                        var cred = $("#ssh_client_server2").val()
                        //$("#ssh-title-1").html($("#ssh_server1").text())
                        $("#ssh-title-2").html("ssh " + cred)
                    }
                })
            sshListenerXHR.error(function (err) {
                showError(err.statusText)
            });
        },
        sshIValidate1 = function sshIValidate() {
            var sshListenerXHR = sshAuthListener1();
            sshListenerXHR
                .done(function (res) {
                    if (res.response === "ok") {
                        showSuccess(res.message)
                        $("#ssh-check-1").removeClass("hidden")
                        //$("#ssh-title-1").html("hidden")
                        var cred = $("#ssh_client_server1").val()
                        //$("#ssh-title-1").html($("#ssh_server1").text())
                        $("#ssh-title-1").html("ssh " + cred)
                    }
                    else if (res.code === "404") {
                        showError(res.message)
                    }
                    else if (res.code === "403") {
                        $("#ssh-credentials-modal").find("#ssh_auth").html($("#ssh_client_server1").val());
                        $("#ssh-credentials-modal").find("#ssh_auth_cgi").val($("#ssh_client_server1").val());
                        $("#ssh-credentials-modal").modal(true)
                    }
                })
            sshListenerXHR.error(function (err) {
                showError(err.statusText)
            });
        },
        sshIValidate2 = function sshIValidate() {
            var sshListenerXHR = sshAuthListener2();
            sshListenerXHR
                .done(function (res) {
                    if (res.response === "ok") {
                        showSuccess(res.message)
                        $("#ssh-check-2").removeClass("hidden")
                        //$("#ssh-title-1").html("hidden")
                        var cred = $("#ssh_client_server2").val()
                        //$("#ssh-title-1").html($("#ssh_server1").text())
                        $("#ssh-title-2").html("ssh " + cred)
                    }
                    else if (res.code === "404") {
                        showError(res.message)
                    }
                    else if (res.code === "403") {
                        $("#ssh-credentials-modal").find("#ssh_auth").html($("#ssh_client_server2").val());
                        $("#ssh-credentials-modal").find("#ssh_auth_cgi").val($("#ssh_client_server2").val());
                        $("#ssh-credentials-modal").modal(true)
                    }
                })
            sshListenerXHR.error(function (err) {
                showError(err.statusText)
            });
        },

    // ----- Init -----

        init = function init() {
            fetchConfiguration()
                .then(applyConfiguration)
                .then(initConfigurationForms);
        };
    var $sshAuth = $("#ssh-auth");
    $sshAuth
        .off('click', ".ssh-auth-validate1")
        .on("click", ".ssh-auth-validate1", function (e) {
            e.preventDefault();
            sshIValidate1();
        });

    $sshAuth
        .off('click', ".ssh-auth-validate2")
        .on("click", ".ssh-auth-validate2", function (e) {
            e.preventDefault();
            sshIValidate2();
        });
    $("#ssh-credentials-modal").on('click', "#sub", function (e) {
	setTimeout(function() {
        //location.reload()
        //e.preventDefault();
        $("#ssh-credentials-modal").modal("hide")
        if ($("#ssh_client_server1").val().length>0)
            sshValidate1();
        if ($("#ssh_client_server2").val().length>0)
            sshValidate2();
	}, (20 * 1000));
    });
    $("#tab_SSH").on('click', function(e) {
        if ($("#ssh_client_server1").val().length>0)
            sshValidate1();
        if ($("#ssh_client_server2").val().length>0)
            sshValidate2();
    });
    return {
        init: init
    }
}();
